=== debian/changelog ===
libretro-beetle-psx (0.9.38.6+git20151019-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:46:38 +0100

libretro-beetle-psx (0.9.38.6+git20151019-3) unstable; urgency=medium

  * Team upload
  * Import packaging to https://salsa.debian.org/
  * Add minimal debian/gbp.conf
  * Use dh-exec instead of manual .sh script for install file
  * Add Appstream metadadata and .libretro file for integration with GNOME Games

 -- Jeremy Bicha <jbicha@debian.org>  Sat, 02 Mar 2019 17:54:46 -0500

libretro-beetle-psx (0.9.38.6+git20151019-2) unstable; urgency=low

  * Changed package maintainer to Debian Games Team.
  * Added patch to reproducible build (Closes: #827148).
  * Added patch to fix hardening-no-fortify-functions.
  * Fixed hardening-no-bindnow.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 12 Jun 2016 21:51:00 -0300

libretro-beetle-psx (0.9.38.6+git20151019-1) unstable; urgency=low

  * Initial release (Closes: #814361).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Wed, 01 Jun 2016 22:13:00 -0300
