=== debian/control ===
Source: libretro-beetle-psx
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
Build-Depends: debhelper (>= 9), dh-exec, libtrio-dev
Standards-Version: 3.9.8
Homepage: https://github.com/libretro/beetle-psx-libretro
Vcs-Git: https://salsa.debian.org/games-team/libretro-beetle-psx.git
Vcs-Browser: https://salsa.debian.org/games-team/libretro-beetle-psx

Package: libretro-beetle-psx
Architecture: any
Multi-Arch: same
Depends: retroarch | libretro-frontend, ${misc:Depends}, ${shlibs:Depends}
Description: Libretro wrapper for the Beetle PSX core
 This wrapper makes Beetle PSX core API compatible with libretro, thus
 allowing its use with libretro frontends, such as RetroArch.
 .
 Beetle is a fork of Mednafen for libretro. This core emulates the PlayStation
 console.
 .
 PlayStation is a registered trademark of Sony Computer Entertainment Inc.
 Mednafen/Beetle PSX is not affiliated with or endorsed by any of the companies
 mentioned. The emulator is for educational and development purposes only and it
 may not be used to play games you do not legally own.
