=== debian/changelog ===
libretro-beetle-psx (0.9.44.43-2) bookworm; urgency=low

  * New GIT snapshot.
  * d/rules:
    + use system zlib
  * d/patches/debug-biospath.diff

 -- Sébastien Noel <sebastien@twolife.be>  Fri, 28 Feb 2025 15:32:06 +0100
