=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
-Build-Depends: debhelper (>= 9), dh-exec, libtrio-dev
-Standards-Version: 3.9.8
+Build-Depends: debhelper-compat (=13), dh-exec, pkgconf, libgl-dev, zlib1g-dev
+Standards-Version: 4.7.2
 Homepage: https://github.com/libretro/beetle-psx-libretro
 Vcs-Git: https://salsa.debian.org/games-team/libretro-beetle-psx.git
 Vcs-Browser: https://salsa.debian.org/games-team/libretro-beetle-psx
@@ -24,3 +24,11 @@
  Mednafen/Beetle PSX is not affiliated with or endorsed by any of the companies
  mentioned. The emulator is for educational and development purposes only and it
  may not be used to play games you do not legally own.
+
+Package: kodi-game-libretro-beetle-psx
+Architecture: any-amd64 any-arm64 any-arm any-i386 any-powerpc any-ppc64 any-ppc64el any-riscv64 any-s390x any-sparc64
+Multi-Arch: same
+Depends: kodi-game-libretro, libretro-beetle-psx, ${misc:Depends}
+Enhances: kodi
+Description: Kodi integration for Beetle PSX 
+ Sony - PlayStation (Beetle PSX) core for kodi's retroplayer
