=== debian/rules ===
#!/usr/bin/make -f

# Fix hardening-no-bindnow
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(ARCH),armhf)
	PLATFORM=platform="armv hardfloat"
endif

%:
	dh $@

override_dh_auto_build:
	#dh_auto_build -- SYSTEM_ZLIB=1 HAVE_VULKAN=1 HAVE_OPENGL=1 $(PLATFORM)
	dh_auto_build -- SYSTEM_ZLIB=1 $(PLATFORM)
